import { Identifier, Node } from 'decaffeinate-parser/dist/nodes';
/**
 * Gets the identifiers for the given LHS value.
 *
 * @example
 *
 *   Given `a`, returns [`a`].
 *   Given `[a, b]`, returns [`a`, `b`].
 *   Given `{a, b: c}`, returns [`a`, `c`].
 *   Given `[a, {b, c: d}]`, returns [`a`, `b`, `d`].
 */
export default function leftHandIdentifiers(node: Node): Array<Identifier>;
